<?php
/**
 * Store Commander
 *
 * @category administration
 * @author Store Commander - support@storecommander.com
 * @version 2.2.0
 * @uses Prestashop modules
 * @since 2009
 * @copyright Copyright &copy; 2009-2023, Store Commander
 * @license commercial
 * All rights reserved! Copying, duplication strictly prohibited
 *
 * *****************************************
 * *           STORE COMMANDER             *
 * *   http://www.StoreCommander.com       *
 * *            V 2.2.0                    *
 * *****************************************
 *
 * Compatibility: PS version: 1.6.1 to 8
 *
 **/


class AdminStoreCommander extends ModuleAdminController
{

    public function __construct()
    {
        $this->display = 'view';
        if (version_compare(_PS_VERSION_, '1.5.0.0', '>=')) {
            $this->multishop_context = false;
            $this->multishop_context_group = false;
        }
        parent::__construct();
    }

    public function renderView()
    {
        $link = Context::getContext()->link;
        $cookie = Context::getContext()->cookie;

        $this->addCSS(__PS_BASE_URI__.'/modules/storecommander/views/css/admin.css', 'all');
        $sc_title = "";
        $sc_url = "";
        //
        // Login as selected user on the front office
        // Fix connection for specific 1.5 shops
        //
        $_html = "";
        $sc_access_params = null;
        if(version_compare(_PS_VERSION_, '1.7.0.0', '>=') && Tools::getIsset("REDIRECTADMIN")){
            $subaction = Tools::getValue('subaction',"catalog");
            $url_redir = "";
            if($subaction=="addproduct")
            {
                global $kernel; // sf kernel
                if ($kernel instanceof Symfony\Component\HttpKernel\HttpKernelInterface) {
                    $sfRouter = $kernel->getContainer()->get('router');
                }
                $url_redir = $sfRouter->generate('admin_product_new');
            }
            else
            {
                $urlParams = Tools::getValue('urlParams',array());
                $anchor = "";
                if(!empty($urlParams["anchor"]))
                {
                    $anchor = $urlParams["anchor"];
                    unset($urlParams["anchor"]);
                }
                $link = new Link();
                $url_redir = $link->getAdminLink($subaction, true, $urlParams).$anchor;
            }
            if(!empty($url_redir))
            {
                header("location: ".(Configuration::get('PS_SSL_ENABLED') ? _PS_BASE_URL_SSL_ : _PS_BASE_URL_).$url_redir);
            }
        } else {
            $scdir = Configuration::getGlobalValue('SC_FOLDER_HASH');
            if ($scdir === false) {
                $this->errors[] = 'Unable to find the Store Commander folder. Please contact <a href="support.storecommander.com" targe="_blank">support.storecommander.com</a>';
            } else {
                $currentFileName = array_reverse(explode("/", $_SERVER['SCRIPT_NAME']));
                $datelastregen = Db::getInstance()->getValue('SELECT last_passwd_gen FROM ' . _DB_PREFIX_ . 'employee WHERE id_employee=' . (int)($cookie->id_employee));
                $sc_access_params = [
                    'ide' => $cookie->id_employee,
                    'key' => md5($cookie->id_employee . $datelastregen),
                    'psap' => $currentFileName[1]
                ];
                $sc_title = "Loading...";
                $sc_url = '../modules/storecommander/' . $scdir . '/'.$this->setScDirByVersion($scdir).'/index.php';
            }
        }
        $this->tpl_view_vars = array(
            'html' => $_html,
            'sc_access_params' => $sc_access_params,
            'sc_url' => $sc_url,
            'sc_title' => $sc_title
        );
        return parent::renderView();
    }

    private function setScDirByVersion($scFolder = null)
    {
        if(!$scFolder) {
            $scFolder = Configuration::getGlobalValue('SC_FOLDER_HASH');
        }
        if(version_compare(PHP_VERSION, '8.0.0', '>=') &&
            version_compare(_PS_VERSION_, '8.0.0', '>=') &&
            file_exists(_PS_MODULE_DIR_.'storecommander/'.$scFolder.'/SCR/'))
        {
            return 'SCR';
        }
        return 'SC';
    }
}
